// This is for debugging. I commented it out instead of removed it because I didn't want to write it again, in case I want to make a new version of this addon.
// function db() {
// 	exec("add-ons/script_shortadmincmd/client.cs");
// }
if(!isObject(CustomCommandGui)) exec("./CustomCommandGui.gui");
if(!isObject(CCGCommandData)) new ScriptObject(CCGCommandData);
package shortadmincmd {
	function MM_AuthBar::blinkSuccess(%this) {
		if($CustomCommandGui::BaseSystem::LoadedOptionsButton) {
			Parent::blinkSuccess(%this);
			return;
		}
		$CustomCommandGui::BaseSystem::LoadedOptionsButton = 1;
		%obj = new GuiBitmapButtonCtrl() {
			profile = "BlockButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "509 427";
			extent = "111 25";
			minExtent = "8 2";
			enabled = "1";
			visible = "1";
			clipToParent = "1";
			command = "canvas.popDialog(optionsDlg);Canvas.pushDialog(CustomCommandGui);";
			text = "Short Commands";
			groupNum = "-1";
			buttonType = "PushButton";
			bitmap = "base/client/ui/button1";
			lockAspectRatio = "0";
			alignLeft = "0";
			alignTop = "0";
			overflowImage = "0";
			mKeepCached = "0";
			mColor = "255 255 255 255";
		};
		optionsDlg.getObject(0).add(%obj);
		if($Pref::CustomCommand::DefaultPreset !$= "") CCG_loadCommands($Pref::CustomCommand::DefaultPreset);
		Parent::blinkSuccess(%this);
	}
	function NMH_Type::send(%this) {
		%txt = %this.getvalue();
		%gotSpecial = 1;
		for(%i=0;%i<getWordCount(%txt);%i++) {
			if(%i == 0) continue;
			if(strLen(getWord(%txt,%i)) == 0) continue;
			if(!%quoteGroup && getSubStr(getWord(%txt,%i),0,1) $= "\"") {
				// Quote group
				%quoteGroup = 1;
				%quoteGroupData = getWord(%txt,%i);
				continue;
			}
			if(%quoteGroup && getSubStr(getWord(%txt,%i),strLen(getWord(%txt,%i))-1,1) $= "\"") {
				// End of quote group
				%quoteGroup = 0;
				%args = %args @ ","@%quoteGroupData SPC getWord(%txt,%i);
				continue;
			}
			if(%quoteGroup) {
				%quoteGroupData = %quoteGroupData SPC getWord(%txt,%i);
				continue;
			}
			%args = %args @ ",\""@getWord(%txt,%i)@"\"";
		}
		if(%quoteGroup) {
			newChatHud_addLine("\c0Parse error: \c7Orphaned quote!");
			canvas.popDialog(newMessageHud);
			return;
		}
		%gotSpecial = 0;
		for(%i=1;%i<CCGCommandData.dataCount+1;%i++) {
			%data = CCGCommandData.customData[%i];
			if(strIPos(firstWord(%txt),"/"@getField(%data,0)) == -1) continue;
			%cmd = getField(%data,1);
			%gotSpecial = 1;
			break;
		}
		if(%gotSpecial) {
			canvas.popDialog(newMessageHud);
			eval("commandToServer('"@%cmd@"'"@%args@");");
			return;
		}
		Parent::send(%this);
	}
	function CCG_List::clear(%this) {
		Parent::clear(%this);
		%obj = new GuiSwatchCtrl(CCGPROTECT) {
			dontCount = 1;
		};
		%obj.setVisible(0);		
		%this.add(%obj);
	}
};
activatePackage(shortadmincmd);
function removeCCGCommand(%guiObj,%dataID,%confirm) {
	%data = CCGCommandData.customData[%dataID];
	if(%data $= "") return;
	if(!%confirm) {
		messageBoxYesNo("Confirm","You selected this shortcut:<br><br>/"@getField(%data,1) SPC "to" SPC "/"@getField(%data,0)@"<br><br>Are you sure you want to delete this shortcut?","removeCCGCommand("@%guiObj@","@%dataID@",1);");
		return;
	}
	CCGCommandData.customData[%dataID] = "";
	for(%i=0;%i<CCGCommandData.dataCount+1;%i++) {
		if(%i < %dataID) continue; 
		if(CCGCommandData.customData[%i+1] $= "") {
			CCGCommandData.customData[%i] = "";
			continue;
		}
		CCGCommandData.customData[%i] = CCGCommandData.customData[%i+1];
	}
	CCGCommandData.customData[%i] = "";
	CCGCommandData.dataCount--;
	if(isObject(%guiObj)) %guiObj.delete();
	for(%i=%dataID;%i<CCG_List.getCount();%i++) {
		%obj = CCG_List.getObject(%i);
		if(%obj.dontCount) continue;
		if(%obj.dataID $= "") continue;
		if(%obj.dataID < %dataID) continue;
		%obj.dataID -= 1;
		%obj.getObject(1).command = "removeCCGCommand("@%obj@","@%obj.dataID@");";
	}
	CustomCommandGui.sortListEntries();
}
function CustomCommandGui::sortListEntries(%this) {
	%this = CCG_List;
	if(isObject(AddCommandButton)) AddCommandButton.delete();
	for(%i=0;%i<%this.getCount();%i++) {
		%obj = %this.getObject(%i);
		if(%obj.dontCount) continue;
		if(isObject(%lastObj)) {
			%obj.resize(3,3,getWord(%this.getExtent(),0)-6,31);
			%obj.placeBelow(%lastObj,3);
		} else
			%obj.resize(3,3,getWord(%this.getExtent(),0)-6,31);

		%lastObj = %obj;
	}
	CustomCommandGui.bringToFront(CCGPROTECT);
	CustomCommandGui.addAddButton(1);
	if(isObject(%lastObj)) {
		AddCommandButton.resize(3,3,getWord(%this.getExtent(),0)-6,31);
		AddCommandButton.placeBelow(%lastObj,3);
	} else
		AddCommandButton.resize(3,3,getWord(%this.getExtent(),0)-6,31);

}
function CustomCommandGui::loadTopMenus(%this) {
	CCG_Menu.clearMenus();
	CCG_Menu.addMenu("Preset Bar",0);
	for(%i=1;%i<11;%i++) {
		CCG_Menu.addMenu("\c0"@%i,%i);
		CCG_Menu.addMenuItem(%i,"Save preset",1);
		CCG_Menu.addMenuItem(%i,"-",0);
		CCG_Menu.addMenuItem(%i,"Load preset",2);
		CCG_Menu.addMenuItem(%i,"Delete preset",3);
		CCG_Menu.addMenuItem(%i,"-",0);
		CCG_Menu.addMenuItem(%i,"Set default",4);
		if($Pref::CustomCommand::DefaultPreset == %i) CCG_Menu.setMenuItemChecked(%i,4,1);
		if(!isFile("config/client/ClayHansonAddons/commandlist_presets/"@%i@".txt")) {
			CCG_Menu.setMenuItemEnable(%i,2,0);
			CCG_Menu.setMenuItemEnable(%i,3,0);
			CCG_Menu.setMenuItemEnable(%i,4,0);
			if($Pref::CustomCommand::DefaultPreset == %i) $Pref::CustomCommand::DefaultPreset = "";
			CCG_Menu.setMenuItemChecked(%i,4,0);
		} else 
			CCG_Menu.setMenuText(%i,"\c1"@%i);

	}
}
function CustomCommandGui::onWake(%this) {
	%list = CCG_List;
	%data = CCGCommandData;
	%list.clear();
	CCG_Main.CenterX();
	CCG_Main.CenterY();
	%this.loadTopMenus();
	CCG_AddCmd.setVisible(0);
	for(%i=1;%i<CCGCommandData.dataCount+1;%i++) {
		%data = CCGCommandData.customData[%i];
		%this.addCommand(getField(%data,0),getField(%data,1),%i);
	}
	%this.sortListEntries();
}
function CustomCommandGui::addCommand(%this,%from,%to,%DataID) {
	if(%DataID $= "") CCGCommandData.customData[CCGCommandData.dataCount++] = %from TAB %to TAB getDateTime();
	%date = getField(CCGCommandData.customData[(%DataID $= "" ? CCGCommandData.dataCount : %DataID)],2);
	%obj = new GuiSwatchCtrl() {
		profile = "GuiDefaultProfile";
		horizSizing = "width";
		vertSizing = "bottom";
		position = "0 1";
		extent = "120 31";
		minExtent = "8 2";
		enabled = "1";
		dataID = (%DataID $= "" ? CCGCommandData.dataCount : %DataID);
		visible = "1";
		clipToParent = "1";
		color = "100 100 100 255";

		new GuiMLTextCtrl() {
			profile = "GuiMLTextProfile";
			horizSizing = "width";
			vertSizing = "center";
			position = "7 7";
			extent = "84 16";
			minExtent = "8 2";
			enabled = "1";
			visible = "1";
			clipToParent = "1";
			lineSpacing = "2";
			allowColorChars = "0";
			maxChars = "-1";
			text = "<font:Arial Bold:16><color:00ff00>/"@%from@"<color:ffffff> to<color:00ff00> /"@%to@"<just:right><font:Arial Italic:14><color:ffffff>Added on "@getWord(%date,0) SPC "at" SPC getWord(%date,1)@"  ";
			maxBitmapHeight = "-1";
			selectable = "0";
			autoResize = "1";
		};
		new GuiButtonCtrl() {
			profile = "GuiButtonProfile";
			horizSizing = "left";
			vertSizing = "center";
			position = "91 3";
			extent = "25 25";
			minExtent = "8 2";
			enabled = "1";
			visible = "1";
			clipToParent = "1";
			command = "";
			text = "X";
			groupNum = "-1";
			buttonType = "PushButton";
		};
	};
	%obj.getObject(1).command = "removeCCGCommand("@%obj@","@%obj.dataID@");";
	CCG_List.add(%obj);
	%this.sortListEntries();
}
function CustomCommandGui::addAddButton(%this,%dontSort) {
	%obj = new GuiSwatchCtrl(AddCommandButton) {
		profile = "GuiDefaultProfile";
		horizSizing = "width";
		vertSizing = "bottom";
		position = "0 1";
		extent = "120 31";
		minExtent = "8 2";
		enabled = "1";
		visible = "1";
		clipToParent = "1";
		color = "100 100 100 255";

		new GuiMLTextCtrl() {
			profile = "GuiMLTextProfile";
			horizSizing = "width";
			vertSizing = "center";
			position = "7 7";
			extent = "84 16";
			minExtent = "8 2";
			enabled = "1";
			visible = "1";
			clipToParent = "1";
			lineSpacing = "2";
			allowColorChars = "0";
			maxChars = "-1";
			text = "<font:Arial Bold:16><color:ffffff>Add command shortcut...<just:right><font:Arial Italic:14>Add a new shortened command  ";
			maxBitmapHeight = "-1";
			selectable = "0";
			autoResize = "1";
		};
		new GuiButtonCtrl() {
			profile = "GuiButtonProfile";
			horizSizing = "left";
			vertSizing = "center";
			position = "91 3";
			extent = "25 25";
			minExtent = "8 2";
			enabled = "1";
			visible = "1";
			clipToParent = "1";
			command = "openAddCustomCommandWindow();";
			text = "+";
			groupNum = "-1";
			buttonType = "PushButton";
		};
	};
	CCG_List.add(%obj);
	if(!%dontSort) %this.sortListEntries();
}
function openAddCustomCommandWindow() {
	CCG_AC_Reg.setValue("");
	CCG_AC_Short.setValue("");
	CCG_AddCmd.CenterX();
	CCG_AddCmd.CenterY();
	CCG_AddCmd.setVisible(1);
	CustomCommandGui.pushToBack(CCG_AddCmd);
}
function addCommandToCCG() {
	%reg = firstWord(StripChars(StripMLControlChars(CCG_AC_Reg.getValue()),"/\\[]{}:\",./<>?"));
	%short = firstWord(StripChars(StripMLControlChars(CCG_AC_Short.getValue()),"/\\[]{}:\",./<>?"));
	if(%reg $= "" || %short $= "") {
		messageBoxOk("Error","Please enter info into all of the boxes.");
		return;
	}
	CustomCommandGui.addCommand(%short,%reg);
	CCG_AddCmd.setVisible(0);
}
function CCG_saveCommands(%presetNumber) {
	%saveFile = "config/client/ClayHansonAddons/commandlist_presets/"@%presetNumber@".txt";
	%SO = new FileObject();
	%SO.openForWrite(%saveFile);
	for(%i=1;%i<CCGCommandData.dataCount+1;%i++) {
		%data = CCGCommandData.customData[%i];
		%SO.writeLine(%data);
	}
	%SO.close();
	%SO.delete();
	CustomCommandGui.loadTopMenus();
}
function CCG_loadCommands(%presetNumber) {
	backTrace();
	%saveFile = "config/client/ClayHansonAddons/commandlist_presets/"@%presetNumber@".txt";
	
	if(!isFile(%saveFile)) return;
	CCG_List.clear();
	CCGCommandData.dataCount = 0;
	%SO = new FileObject();
	%SO.openForRead(%saveFile);
	while(!%SO.isEOF()) {
		%strLine = %SO.readLine();
		if(%strLine !$= "") CCGCommandData.customData[CCGCommandData.dataCount++] = %strLine;
	}
	%SO.close();
	%SO.delete();
	CustomCommandGui.onWake();
}
// Favorite menu
function CCG_Menu::onMenuSelect(%this, %menuID, %menuTxt) {
	if(%menuID != 0) return;
	messageBoxOk("Info","The preset bar acts as a 'favorites bar' (like the one found in the brick selection menu to quickly load a set of bricks)");
	return;
}
function CCG_Menu::onMenuItemSelect(%this,%menuID,%menuTxt,%menuItemID,%menuItemTxt) {
	%saveFile = "config/client/ClayHansonAddons/commandlist_presets/"@%menuID@".txt";
	switch(%menuItemID) {
		case 1:
			// Save
			CCG_saveCommands(%menuID);
		case 2:
			// Load
			CCG_loadCommands(%menuID);
		case 3:
			// Delete
			messageBoxYesNo("Confirm","Are you sure you want to delete this preset?","fileDelete(\""@%saveFile@"\");CustomCommandGui.loadTopMenus();");
		case 4:
			// Set default
			$Pref::CustomCommand::DefaultPreset = %menuID;
			messageBoxOk("Info","This preset will be automatically loaded next time the game is launched.");
			CustomCommandGui.loadTopMenus();
	}
}